# -*- coding: utf-8 -*-

# License : public domain

#=============START OF CODE TO BE COPIED
from gimpfu import *

versionMinor = gimp.version[1]
if versionMinor == 8:
	for constant in globals().keys():
		if 'MODE' in constant:
			newName = 'LAYER_MODE_' + constant[:-5]
			#~ print newName
			globals()[newName] = globals()[constant]
def gmic(*args):
	if 'plug_in_gmic_qt' in dir(pdb):
		return pdb.plug_in_gmic_qt(args[0], args[1], args[2], args[3], '-fx_'+ args[4])
	else:
		return pdb.plug_in_gmic(args[0], args[1], args[2], '-gimp_'+ args[4])

lang = t.info()['language'][:2] if t.info() else 'en'
#~ print 'Info : lang=' + lang

def _(ps_cle):
	try:
		return trans[ps_cle][lang]
	except KeyError:
		print 'Info : KeyError:trans[ps_cle][lang]'
		try:
			return trans[ps_cle]['en']
		except KeyError:
			print "Info : KeyError:trans[ps_cle]['en']"
			try:
				return trans[ps_cle]['fr']
			except KeyError:
				return ps_cle
#=============END OF CODE TO BE COPIED

trans = {
	'boxEffect': {
		'fr': u"Boîte métallique",
		'en': u"Metal Box",
		'de': u"Metall Schachtel",
		'es': u"Caja metálica",
		'it': u"Scatola metallica",
	},
	'blur': {
		'fr': u"Rayon de flou",
		'en': u"Blur Radius",
		'de': u"Weichzeichnenradius",
		'es': u"Radio del desenfoque",
		'it': u"Raggio di sfocatura",
	},
	'grain': {
		'fr': u"Aspect granuleux",
		'en': u"Graininess",
		'de': u"Körnige Oberfläche",
		'es': u"Apariencia granulada",
		'it': u"Disturbo",
	},
	'grooveSmooth': {
		'fr': u"Douceur de la rainure",
		'en': u"Groove Smoothness",
	},
}

def boxEffect(img, layer, blur, grain, grooveSmooth):
	gimp.context_push()
	img.undo_group_start()

	# preparation
	gimp.progress_init(_('boxEffect') + '...')
	hei = layer.height
	wid = layer.width
	pdb.gimp_layer_flatten(layer)
	
	layerCopy = pdb.gimp_layer_copy(layer, False)
	pdb.gimp_image_add_layer(img, layerCopy, 0)
	
	# kaleidoscope
	pdb.gimp_image_set_active_layer(img, layer)
	gmic(img, layer, 1, 0, 'kaleidoscope 50,50,0,0,100,10,2')
	pdb.plug_in_gauss(img, layer, blur, blur, 1)
	
	# bord
	layerBord = pdb.gimp_layer_new(img, wid, hei, 0, 'bord', 100, 0)
	pdb.gimp_image_add_layer(img, layerBord, 0)
	
	pdb.gimp_image_set_active_layer(img, layerBord)
	gmic(img, layerBord, 1, 0, 'frame_round 6,20,1,0,255,255,255,255,0,0,3')
	
	bordChannel = pdb.gimp_channel_new_from_component(img, 0, 'bordChannel')
	pdb.gimp_image_insert_channel(img, bordChannel, None, 0)
	mask = pdb.gimp_layer_create_mask(layerCopy, 6)
	pdb.gimp_layer_add_mask(layerCopy, mask)
	pdb.gimp_invert(mask)
	
	# groove
	pdb.plug_in_edge(img, layerBord, 2, 3, 0)
	
	pdb.gimp_image_set_active_layer(img, layerBord)
	gmic(img, layerBord, 1, 0, 'smooth_antialias 100,10,5,0,50,50')
	
	pdb.plug_in_gauss(img, layerBord, grooveSmooth, grooveSmooth, 1)
	pdb.plug_in_emboss(img, layerBord, 315, 45, 6, True)
	pdb.gimp_curves_spline(layerBord, 0, 6, [0,0,180,128,255,255])
	pdb.gimp_layer_set_mode(layerBord, LAYER_MODE_GRAIN_MERGE)
	
	# noise
	pdb.gimp_image_merge_down(img, layerCopy, 0)
	res = pdb.gimp_image_merge_down(img, layerBord, 0)
	
	pdb.gimp_image_set_active_layer(img, res)
	gmic(img, res, 1, 0, 'noise ' + str(int(grain)) + ',0,0,1,0,50,50')
	#~ pdb.plug_in_hsv_noise(img, res, )

	img.undo_group_end()
	gimp.context_pop()


register(
	"python-fu-boxeffect", # name
	_('boxEffect'), #
	"Box effect . . .", # help
	"cli345", # author
	"cli345", # copyright
	"2021-05-08", # date
	_('boxEffect') + '...', # menu name
	"RGB,RGBA",
	[
		(PF_IMAGE, "image",       "Input image", None),
		(PF_DRAWABLE, "drawable", "Input drawable", None),
		(PF_SLIDER, "blur", _('blur'), 25, (0,50,1)),
		(PF_SLIDER, "grain", _('grain'), 12, (0,50,1)),
		(PF_SLIDER, "grooveSmooth", _('grooveSmooth'), 10, (0,25,1)),
	],
	[],
	boxEffect,
	menu="<Image>/Filters/Artistic",
)

#=============START OF CODE TO BE COPIED
from gimpfu import _query, _run
gimp.main(_query, None, lambda:None, _run)
#~ main()
#=============END OF CODE TO BE COPIED
